# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Perl-Critic-Lax
Version:	0.014
Release:	2.%{__distinit}%{__distvers}
Summary:	Policies that let you slide on common exceptions
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/Perl-Critic-Lax
Source0:	https://cpan.metacpan.org/modules/by-module/Perl/Perl-Critic-Lax-%{version}.tar.gz
Patch0:		Perl-Critic-Lax-0.014-old-EU::MM.patch
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(:VERSION) >= 5.12
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module Runtime
BuildRequires:	perl(parent)
BuildRequires:	perl(Perl::Critic) >= 1.088
BuildRequires:	perl(Perl::Critic::Policy)
BuildRequires:	perl(Perl::Critic::Policy::ValuesAndExpressions::ProhibitLeadingZeros)
BuildRequires:	perl(Perl::Critic::Utils)
BuildRequires:	perl(Readonly)
BuildRequires:	perl(strict)
BuildRequires:	perl(utf8)
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(Perl::Critic::TestUtils)
BuildRequires:	perl(Test::More) >= 0.88
# Optional Tests
BuildRequires:	perl(CPAN::Meta) >= 2.120900
# Extra Tests
BuildRequires:	perl(Encode)
BuildRequires:	perl(Test::Pod) >= 1.41
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
Requires:	perl(Perl::Critic) >= 1.088
# Old provides generator does not support the syntax used in this module
%if 0%{?fedora} < 21 && 0%{?rhel} < 8
Provides:	perl(Perl::Critic::Lax) = %{version}
Provides:	perl(Perl::Critic::Policy::Lax::ProhibitComplexMappings::LinesNotStatements) = %{version}
Provides:	perl(Perl::Critic::Policy::Lax::ProhibitEmptyQuotes::ExceptAsFallback) = %{version}
Provides:	perl(Perl::Critic::Policy::Lax::ProhibitLeadingZeros::ExceptChmod) = %{version}
Provides:	perl(Perl::Critic::Policy::Lax::ProhibitStringyEval::ExceptForRequire) = %{version}
Provides:	perl(Perl::Critic::Policy::Lax::RequireConstantOnLeftSideOfEquality::ExceptEq) = %{version}
Provides:	perl(Perl::Critic::Policy::Lax::RequireEndWithTrueConst) = %{version}
Provides:	perl(Perl::Critic::Policy::Lax::RequireExplicitPackage::ExceptForPragmata) = %{version}
%endif

%description
The Perl-Critic-Lax distribution includes versions of core Perl::Critic
modules with built-in exceptions. If you really like a Perl::Critic policy,
but find that you often violate it in a specific way that seems pretty darn
reasonable, maybe there's a Lax policy. If there isn't, send one in!

%prep
%setup -q -n Perl-Critic-Lax-%{version}

# Don't really need ExtUtils::MakeMaker ≥ 6.78
%patch -P 0

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test
make test TEST_FILES="$(echo $(find xt/ -name '*.t'))"

%files
%license LICENSE
%doc Changes README
%{perl_vendorlib}/Perl/
%{_mandir}/man3/Perl::Critic::Lax.3*
%{_mandir}/man3/Perl::Critic::Policy::Lax::ProhibitComplexMappings::LinesNotStatements.3*
%{_mandir}/man3/Perl::Critic::Policy::Lax::ProhibitEmptyQuotes::ExceptAsFallback.3*
%{_mandir}/man3/Perl::Critic::Policy::Lax::ProhibitLeadingZeros::ExceptChmod.3*
%{_mandir}/man3/Perl::Critic::Policy::Lax::ProhibitStringyEval::ExceptForRequire.3*
%{_mandir}/man3/Perl::Critic::Policy::Lax::RequireConstantOnLeftSideOfEquality::ExceptEq.3*
%{_mandir}/man3/Perl::Critic::Policy::Lax::RequireEndWithTrueConst.3*
%{_mandir}/man3/Perl::Critic::Policy::Lax::RequireExplicitPackage::ExceptForPragmata.3*

%changelog
* Wed Jul 19 2023 Paul Howarth <paul@city-fan.org> - 0.014-2
- Avoid use of deprecated patch syntax

* Sun Jan  1 2023 Paul Howarth <paul@city-fan.org> - 0.014-1
- Update to 0.014
  - Update packaging and metadata
  - Minimum required Perl is now v5.12
- Use SPDX-format license tag
- Add patch to support building with ExtUtils::MakeMaker < 6.78

* Tue Apr  6 2021 Paul Howarth <paul@city-fan.org> - 0.013-13
- Switch upstream from search.cpan.org to metacpan.org
- Use %%license unconditionally

* Tue Apr 17 2018 Paul Howarth <paul@city-fan.org> - 0.013-4
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section
  - Drop workarounds for building with Test::More < 0.88

* Tue Mar 14 2017 Paul Howarth <paul@city-fan.org> - 0.013-1
- Update to 0.013
  - Tiny doc change: guys ⇒ people
- Update patches as needed

* Thu Aug 25 2016 Paul Howarth <paul@city-fan.org> - 0.012-1
- Update to 0.012
  - ProhibitLeadingZeros::ExceptChmod is now just an empty subclass of
    ProhibitLeadingZeros, which has allowed leading zeroes on args to chmod
    since 2008
  - Policy ValuesAndExpressions::RequireConstantOnLeftSideOfEquality has been
    added to allow variables on the left side of 'eq'
- Classify buildreqs by usage
- Simplify find command using -delete
- Update patches as needed

* Tue Sep 16 2014 Paul Howarth <paul@city-fan.org> - 0.011-2
- Use %%license where possible

* Fri Jul 11 2014 Paul Howarth <paul@city-fan.org> - 0.011-1
- Update to 0.011
  - Avoid crashing when encountering unusual PPI documents
- Update patches as needed
- Drop support for old distributions prior to FC-5
  - Drop %%defattr, redundant since rpm 4.4
  - Drop patch for building with ExtUtils::MakeMaker < 6.30

* Thu Oct 10 2013 Paul Howarth <paul@city-fan.org> - 0.010-1
- Update to 0.010
  - Update bugtracker and repo metadata
- Update patches for building with old Test::More versions

* Tue Sep 11 2012 Paul Howarth <paul@city-fan.org> - 0.009-1
- Update to 0.009
  - Repackage with Dist::Zilla, primarily to fix busted metadata
- Drop BR: perl(base), perl(Cwd), perl(File::Path) and perl(File::Spec)
  since we're no longer using Module::Install
- Drop BR: perl(Test::Pod::Coverage) as coverage test has gone
- BR: perl(File::Temp) and perl(parent)
- Bump perl(Test::Pod) version requirement to 1.41
- Add patches to handle building with old ExtUtils::MakeMaker and
  Test::More versions on older distributions

* Fri Jul 13 2012 Paul Howarth <paul@city-fan.org> - 0.008-5
- BR: perl(base), perl(Cwd), perl(File::Path) and perl(File::Spec)
- Don't need to remove empty directories from the buildroot

* Tue Feb 21 2012 Paul Howarth <paul@city-fan.org> - 0.008-4
- Import from Fedora
- Install to vendor directories
- Reinstate compatibility with old distributions like EL-5

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.008-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Jul 19 2011 Petr Sabata <contyk@redhat.com> - 0.008-2
- Perl mass rebuild

* Thu Jan 27 2011 Petr Pisar <ppisar@redhat.com> 0.008-1
- Specfile autogenerated by cpanspec 1.78
- Remove BuildRoot stuff
- Install into perl core directory
